! http://telematica.cicese.mx/computo/super/cicese2000/scsl/ejemploF.html 
! f95 sistema_linear_lapack.f90 -llapack
!sistema_orde4.dat: x=1 y=0 z=-1 t=2; sistema={x+y+z+t=2, x-y-z+t=4, -x+z=-2, y+z+t=1}
! 1 1 1 1 2
! 1 -1 -1 1 4
! -1 0 1 0 -2
! 0 1 1 1 1
!----------------------------------------------
!sistema_orde5.dat: x=1 y=2 z=0 t=-1 u=0; sistema={x+y-z+t+u=2;x-y+t+u=1;x+z-u=0;
! x-y-z+t+u=2;x-y+z-t+u=1}
!    1   1   1   1   1   2
!    2  -1   0  -1  -1   1
!   -1   0   1  -1   1   0
!    1   1   0   1  -1   2
!    0   1  -1   1   0   1
program sistema_linear
real,allocatable :: a(:,:)
real,allocatable :: b(:)
integer,allocatable :: pivote(:)
character(len=1) :: incog(10)=(/'x','y','z','t','u','v','w','r','s','p'/)

open(1,file="sistema_orde4.dat",status="old",err=1)
read (1,*) n
allocate(a(n,n),b(n),pivote(n))
do i = 1, n
  read (1, *) (a(i, j), j = 1, n), b(i)
end do
close(1)

print '(a,i3,a)', "sistema de orde", n, " ="
do i = 1, n
  print '(f7.2,a,$)', a(i,1), incog(1)
  do j = 2, n
    if(a(i,j) >= 0) then
      print '(a,f7.2,a,$)', ' + ', a(i, j), incog(j)
    else
      print '(a,f7.2,a,$)', ' - ', -a(i, j), incog(j)
    endif
  end do
  print '(a,f7.2)', ' = ', b(i)
end do


call sgesv(n, 1, a, n, pivote, b, n, info)

print *, "solucion:"
do i = 1, n
  print '(2a,f6.2)', incog(i), ' = ', b(i)
end do

deallocate(a,b,pivote)
stop
1 print *, "erro en open"
stop
end program sistema_linear
